<?php

class MY_Lang extends MX_Lang {

    var $language = array();
    var $is_loaded = array();
    var $idiom;
    var $module;
    var $line;
    var $CI;

    function __construct() {
        parent::__construct();
    }

    /**
     * Load a language file
     *
     * @access    public
     * @param    mixed    the name of the language file to be loaded. Can be an array
     * @param    string    the language (english, etc.)
     * @return    mixed
     */
    function load($langfile = '', $idiom = '', $return = FALSE) {
        // Calling early before CI reformats them
        $this->module = $langfile;
        $this->idiom = $idiom;
        $langfile = str_replace(EXT, '', str_replace('_lang.', '', $langfile)) . '_lang' . EXT;
        if (in_array($langfile, $this->is_loaded, TRUE)) {
            return;
        }
        if ($idiom == '') {
            $CI = & get_instance();
            $deft_lang = DEFAULT_LANGUAGE;
            $idiom = ($deft_lang == '') ? DEFAULT_LANGUAGE : $deft_lang;

            $this->idiom = $idiom;
        }
        // Determine where the language file is and load it
        if (file_exists(APPPATH . 'language/' . $idiom . '/' . $langfile)) {
            include(APPPATH . 'language/' . $idiom . '/' . $langfile);
        } else {
            if (file_exists(BASEPATH . 'language/' . $idiom . '/' . $langfile)) {
                include(BASEPATH . 'language/' . $idiom . '/' . $langfile);
            } else {
                $database_lang = $this->_get_from_db();
                if (!empty($database_lang)) {
                    $lang = $database_lang;
                } else {
                    //show_error('Unable to load the requested language "' . $idiom . '" for module "' . $this->module . '"');
                }
            }
        }
        if (!isset($lang)) {
            log_message('error', 'Language file contains no data: language/' . $idiom . '/' . $langfile);
            return;
        }
        if ($return == TRUE) {
            return $lang;
        }
        $this->is_loaded[] = $langfile;
        $this->language = array_merge($this->language, $lang);
        unset($lang);
        log_message('debug', 'Language file loaded: language/' . $idiom . '/' . $langfile);
        return TRUE;
    }

    /**
     * Load a language from database
     *
     * @access    private
     * @return    array
     */
    private function _get_from_db() {
        $CI = & get_instance();
        $return = array();
        if ($this->module == '') {
            $this->module = 'main';
        }
        $CI->load->helper('Languages');
        if (function_exists('get_language_by_module_key')) {
            return get_language_by_module_key($this->module, $this->idiom);
        }
        /*
        $CI->db->cache_on();
        $CI->db->cache_prefix('languages');
        $CI->db->select('*');
        $CI->db->from('languages');
        $CI->db->where('key', $this->idiom);
        if ($this->module != '') {
            $CI->db->where('module', $this->module);
        } else {
            $CI->db->where('module', 'main');
        }
        $CI->db->limit(1);
        $query = $CI->db->get();
        $CI->db->cache_prefix(false);
        $CI->db->cache_off();
        foreach ($query->result() as $row) {
            $return = $row;
        }
        unset($CI, $query);
        return $return;*/
    }

    public function clear_cache($key, $module) {
        $CI = & get_instance();
        $CI->db->select('*');
        $CI->db->from('languages');
        $CI->db->where('key', $key);
        if ($this->module != '') {
            $CI->db->where('module', $module);
        } else {
            $CI->db->where('module', 'main');
        }
        $CI->db->limit(1);
        $query = $CI->db->get();
        $CI->db->cache_delete($CI->db->last_query());
    }

}
