<?php

(defined('BASEPATH')) OR exit('No direct script access allowed');

/* load the MX_Loader class */
require APPPATH . "third_party/MX/Loader.php";

class MY_Loader extends MX_Loader {

    public $modules = array();
    
    public function __construct() {
        parent::__construct();
    }

    /** Load a module helper * */
    public function helper($helper) {
        if ($helper != 'Modules') {
            $this->load->helper('Modules');
            if (!is_array($this->modules) || count($this->modules) == 0) {
                $modules = get_modules_list();
                if (is_array($modules) && count($modules) > 0) {
                    foreach($modules as $module) {
                        $this->modules[$module['keyword']] = $module;
                    }
                }
            }
            if (isset($this->modules[strtolower($helper)])) {
                if (!$this->modules[strtolower($helper)]['status']) {
                    return;
                }
            }
        }
        
        if (is_array($helper))
            return $this->helpers($helper);

        if (isset($this->_ci_helpers[$helper]))
            return;

        list($path, $_helper) = Modules::find(strtolower($helper) . '_helper', $this->_module, 'helpers/');

        if ($path === FALSE) {

            foreach ($this->_ci_prep_filename($helper, '_helper') as $helper) {
                if (isset($this->_ci_helpers[$helper])) {
                    continue;
                }

                $ext_helper = APPPATH . 'helpers/' . config_item('subclass_prefix') . $helper . '.php';

                // Is this a helper extension request?
                if (file_exists($ext_helper)) {
                    $base_helper = BASEPATH . 'helpers/' . $helper . '.php';

                    if (file_exists($base_helper)) {
                        include_once($ext_helper);
                        include_once($base_helper);

                        $this->_ci_helpers[$helper] = TRUE;
                        log_message('debug', 'Helper loaded: ' . $helper);
                        continue;
                    }
                }

                // Try to load the helper
                foreach ($this->_ci_helper_paths as $path) {
                    if (file_exists($path . 'helpers/' . $helper . '.php')) {
                        include_once($path . 'helpers/' . $helper . '.php');

                        $this->_ci_helpers[$helper] = TRUE;
                        log_message('debug', 'Helper loaded: ' . $helper);
                        break;
                    }
                }
            }
        } else {
            Modules::load_file($_helper, $path);
            $this->_ci_helpers[$_helper] = TRUE;
        }
    }

}
