<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');


if (!function_exists('get_service_prefix')) {

    function get_service_prefix() {
        $CI = & get_instance();
        $prefix = '';
        if ($CI->config->item('service') == TRUE) {
            $database_group = str_replace(array('.newsletterplus.net','.yoursiteplus.net'), '', $_SERVER['SERVER_NAME']);
            if ($CI->config->item($database_group) == TRUE) {
                $prefix = $database_group . '/';
            }
        }
        return $prefix;
    }
    
}

if (!function_exists('get_content_type')) {

    function get_content_type($filename) {
        $mime_types = array(
            'txt' => 'text/plain',
            'htm' => 'text/html',
            'html' => 'text/html',
            'php' => 'text/html',
            'css' => 'text/css',
            'js' => 'application/javascript',
            'json' => 'application/json',
            'xml' => 'application/xml',
            'swf' => 'application/x-shockwave-flash',
            'flv' => 'video/x-flv',
            // images
            'png' => 'image/png',
            'jpe' => 'image/jpeg',
            'jpeg' => 'image/jpeg',
            'jpg' => 'image/jpeg',
            'gif' => 'image/gif',
            'bmp' => 'image/bmp',
            'ico' => 'image/vnd.microsoft.icon',
            'tiff' => 'image/tiff',
            'tif' => 'image/tiff',
            'svg' => 'image/svg+xml',
            'svgz' => 'image/svg+xml',
            // archives
            'zip' => 'application/zip',
            'rar' => 'application/x-rar-compressed',
            'exe' => 'application/x-msdownload',
            'msi' => 'application/x-msdownload',
            'cab' => 'application/vnd.ms-cab-compressed',
            // audio/video
            'mp3' => 'audio/mpeg',
            'qt' => 'video/quicktime',
            'mov' => 'video/quicktime',
            // adobe
            'pdf' => 'application/pdf',
            'psd' => 'image/vnd.adobe.photoshop',
            'ai' => 'application/postscript',
            'eps' => 'application/postscript',
            'ps' => 'application/postscript',
            // ms office
            'doc' => 'application/msword',
            'rtf' => 'application/rtf',
            'xls' => 'application/vnd.ms-excel',
            'ppt' => 'application/vnd.ms-powerpoint',
            // open office
            'odt' => 'application/vnd.oasis.opendocument.text',
            'ods' => 'application/vnd.oasis.opendocument.spreadsheet',
        );

        $ext = strtolower(array_pop(explode('.', $filename)));
        if (array_key_exists($ext, $mime_types)) {
            return $mime_types[$ext];
        } else {
            return 'application/octet-stream';
        }
    }

}

if (!function_exists('get_file_extension')) {

    function get_file_extension($file) {
        $file_type = '';
        /* Получаем тип файла */
        if (function_exists('finfo_open')) {
            $_fileinfo = @finfo_open(FILEINFO_MIME);
            if ($_fileinfo) {
                $finfo_data = finfo_file($_fileinfo, $file);
                $t = explode(";", $finfo_data);
                $file_type = trim($t[0]);
            }
        }
        if (!$file_type && function_exists('get_content_type')) {
            $file_type = get_content_type($file);
        }

        if ($file_type == '')
            return 'application/octet-stream';
        return $file_type;
    }

}

if (!function_exists('is_ajax')) {

    function is_ajax() {
        return (isset($_SERVER['HTTP_X_REQUESTED_WITH']) &&
                ($_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest'));
    }

}

if (!function_exists('crop_str')) {

    function crop_str($string, $limit) {
        if (mb_strlen($string) > $limit) {
            $substring_limited = mb_substr($string, 0, $limit);
            return mb_substr($substring_limited, 0, mb_strrpos($substring_limited, ' ')) . ' ...';
        }
        else
            return $string;
    }

}

if (!function_exists('inflection')) {

    function inflection($text = '', $iid = 1) {
        $text = urldecode($text);
        $md5 = md5($text);

        $cases = array();

        if (!is_dir(TEMPPATH . 'inflections/')) {
            @mkdir(TEMPPATH . 'inflections/', DIR_WRITE_MODE);
            @copy(TEMPPATH . 'index.html', TEMPPATH . 'inflections/index.html');
        }
        if (file_exists(TEMPPATH . 'inflections/' . $md5)) {
            $cases = @file_get_contents(TEMPPATH . 'inflections/' . $md5);
            $cases = @unserialize($cases);
        }

        if ($cases) {
            if (isset($cases[$iid])) {
                return $cases[$iid];
            } else {
                return $text;
            }
        } else {
            $url = 'http://export.yandex.ru/inflect.xml?name=' . urlencode($text);
            $curl = @curl_init($url);
            @curl_setopt($curl, CURLOPT_USERAGENT, 'Opera/9.80 (Windows NT 6.1; U; ru) Presto/2.6.30 Version/10.61'); // Just for fun, or ...
            @curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
            $result = @curl_exec($curl);
            @curl_close($curl);
            $cases = array();
            preg_match_all('#\<inflection\s+case\=\"([0-9]+)\"\>(.*?)\<\/inflection\>#si', $result, $m);
            if (count($m[0])) {
                foreach ($m[1] as $i => &$id) {
                    $cases[(int) $id] = $m[2][$i];
                } unset($id);
            }
            if (count($cases) > 1) {
                if (isset($cases[$iid])) {
                    @file_put_contents(TEMPPATH . 'inflections/' . $md5, @serialize($cases));
                    return $cases[$iid];
                } else {
                    return $text;
                }
            } else {
                return $text;
            }
        }
    }

}

if (!function_exists('get_locale')) {

    function get_locale($language = 'english') {
        switch ($language) {
            case 'russian':
                return 'ru_RU';
            default:
                return 'en_US';
        }
    }

}

if (!function_exists('get_lang_code')) {

    function get_lang_code($language = 'english') {
        switch ($language) {
            case 'russian':
                return 'ru';
            default:
                return 'en';
        }
    }

}

if (!function_exists('format_date_str')) {

    function format_date_str($date = 0, $show_time = true) {
        $CI = & get_instance();
        $time_zone_offset = $CI->session->userdata('time_zone_offset');

        $origin_tz = date_default_timezone_get();
        $origin_dtz = new DateTimeZone($origin_tz);
        $origin_dt = new DateTime("now", $origin_dtz);
        $server_offset = $origin_dtz->getOffset($origin_dt);

        if (!$time_zone_offset) {
            $time_zone_type = $CI->session->userdata('time_zone_type');
            $time_zone_value = $CI->session->userdata('time_zone_value');

            if ($time_zone_value) {
                $time_zone_data = explode(' ', $time_zone_value);
                if (isset($time_zone_data[1])) {
                    $time_zone_offset = intval($time_zone_data[1]) * 60 * 60;
                }
            }

            $CI->session->set_userdata('time_zone_offset', $time_zone_offset);
        }
        $date = $date - $server_offset + $time_zone_offset;
        $day = date('j', $date);
        $month = l('month_' . date('n', $date), 'main');
        $year = date('Y', $date);
        return $day . ' ' . $month . ' ' . $year . ' ' . ($show_time ? (l('at', 'main') . ' ' . date('H:i', $date)) : '');
    }

}

if (!function_exists('format_time')) {

    function format_time($date = 0) {
        $CI = & get_instance();
        $time_zone_offset = $CI->session->userdata('time_zone_offset');

        $origin_tz = date_default_timezone_get();
        $origin_dtz = new DateTimeZone($origin_tz);
        $origin_dt = new DateTime("now", $origin_dtz);
        $server_offset = $origin_dtz->getOffset($origin_dt);

        if (!$time_zone_offset) {
            $time_zone_type = $CI->session->userdata('time_zone_type');
            $time_zone_value = $CI->session->userdata('time_zone_value');

            if ($time_zone_value) {
                $time_zone_data = explode(' ', $time_zone_value);
                if (isset($time_zone_data[1])) {
                    $time_zone_offset = intval($time_zone_data[1]) * 60 * 60;
                }
            }

            $CI->session->set_userdata('time_zone_offset', $time_zone_offset);
        }
        $date = $date - $server_offset + $time_zone_offset;
        return $date;
    }

}

if (!function_exists('remove_directory')) {

    function remove_directory($dir) {
        if ($objs = glob($dir . "/*")) {
            foreach ($objs as $obj) {
                is_dir($obj) ? remove_directory($obj) : @unlink($obj);
            }
        }
        rmdir($dir);
    }

}

if (!function_exists('get_youtube_video_id')) {

    function get_youtube_video_id($url = '') {
        $urls = parse_url($url);

        //url is http://youtu.be/xxxx
        if (isset($urls['host']) && $urls['host'] == 'youtu.be') {
            $id = ltrim($urls['path'], '/');
        }
        //url is http://www.youtube.com/embed/xxxx
        else if (isset($urls['path']) && strpos($urls['path'], 'embed') == 1) {
            $id = end(explode('/', $urls['path']));
        }
        //url is xxxx only
        else if (strpos($url, '/') === false) {
            $id = $url;
        }
        //http://www.youtube.com/watch?feature=player_embedded&v=m-t4pcO99gI
        //url is http://www.youtube.com/watch?v=xxxx
        else if (isset($urls['query'])) {
            parse_str($urls['query']);
            $id = $v;
            if (!empty($feature)) {
                $id = end(explode('v=', $urls['query']));
            }
        }
        return $id;
    }

}

if (!function_exists('format_cost_str')) {

    function format_cost_str($cost = 0, $currency_gid = '') {
        $CI = & get_instance();
        $CI->load->helper('Payments');
        $currency = false;
        if ($currency_gid) {
            if (function_exists('get_current_currency_by_gid')) {
                $currency = get_current_currency_by_gid($currency_gid);
            }
        } else {
            if (function_exists('get_current_currency')) {
                $currency = get_current_currency();
            }
        }
        if ($currency) {
            if (!$currency->position || $currency->position == 'right') {
                return $cost . $currency->abbr;
            } else {
                return $currency->abbr . $cost;
            }
        }
        return $cost;
    }

}

if (!function_exists('show_currency_abbr')) {

    function show_currency_abbr($currency_gid = '') {
        $CI = & get_instance();
        $CI->load->helper('Payments');
        $currency = false;
        if ($currency_gid) {
            if (function_exists('get_current_currency_by_gid')) {
                $currency = get_current_currency_by_gid($currency_gid);
            }
        } else {
            if (function_exists('get_current_currency')) {
                $currency = get_current_currency();
            }
        }
        if ($currency) {
            return $currency->abbr;
        }
    }

}

if (!function_exists('unify_dir_separator')) {

    function unify_dir_separator($path = '') {
        $path = str_replace('\\\\', '/', $path);
        $path = str_replace('\\', '/', $path);
        return $path;
    }

}

if (!function_exists('remove_trailing_slash')) {

    function remove_trailing_slash($path = '') {
        if (substr($path, -1) == '/') {
            return substr($path, 0, -1);
        } else {
            return $path;
        }
    }

}

if (!function_exists('remove_leading_slash')) {

    function remove_leading_slash($path = '') {
        if (substr($path, 0, 1) == '/') {
            return substr($path, 1);
        } else {
            return $path;
        }
    }

}

if (!function_exists('format_keyword')) {

    function format_keyword($keyword = '') {
        $keyword = strip_tags($keyword);
        $keyword = strtolower($keyword);
        $keyword = preg_replace("/[^a-z0-9_]/i", "", $keyword);
        return $keyword;
    }

}
