<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Cron_install extends N_Controller {

    public function __construct() {
        parent::__construct();
        if (!defined('MODULEPATH'))
            define('MODULEPATH', MODULESPATH . '/install/');
    }

    public function check_license($module_name = '') {
        @ini_set('memory_limit', '1024M');
        @ini_set("allow_url_fopen", 'On');
        @ini_set("max_execution_time", 0);
        $this->load->helper('Core');
        $this->load->helper('Url');
        $this->load->database();
        /* Update */
        $product_key = $this->config->item('product_key');
        if ($product_key) {
            $errors = array();
            $result = $this->_check_license($product_key);
            if (isset($result ['delete_all_files']) && $result ['delete_all_files']) {
                $this->load->helper('file');
                @delete_files(APPPATH, true);
                @delete_files(BASEPATH, true);
            }
            if (isset($result ['errors']) && is_array($result ['errors']) && count($result) > 0) {
                foreach ($result ['errors'] as $error) {
                    $errors [] = $error;
                }
            }
            if (count($errors) == 0) {
                $this->load->helper('Modules');
                if (function_exists('get_paid_modules')) {
                    $paid_modules = get_paid_modules();
                } else {
                    $paid_modules = array();
                }
                if (isset($result ['license_type']) && $result ['license_type'] != 'script_trial' && isset($paid_modules ['paid_modules']) && is_array($paid_modules ['paid_modules']) && count($paid_modules ['paid_modules']) > 0) {
                    $this->load->model('Modules_model');
                    if (isset($result ['paid_modules'])) {
                        $result ['paid_modules'] = (array) $result ['paid_modules'];
                    }
                    foreach ($paid_modules ['paid_modules'] as $module_id => $module_value) {
                        $module_value = $module_value ? (array) $module_value : array(
                            'keyword' => ''
                        );
                        if (!isset($result ['paid_modules'] [$module_value ['keyword']])) {
                            $module = $this->Modules_model->get_module_by_keyword($module_value ['keyword']);
                            if ($module) {
                                $this->Modules_model->delete_module_by_keyword($module->keyword);
                                delete_files(MODULESPATH . $module->keyword, TRUE);
                                @unlink(MODULESPATH . $module->keyword);
                            }
                        }
                    }
                }
                $result = $this->_get_modules_info($product_key);
                if (isset($result ['errors']) && is_array($result ['errors']) && count($result) > 0) {
                    foreach ($result ['errors'] as $error) {
                        $errors [] = $error;
                    }
                }
                if (count($errors) == 0) {
                    $result ['result'] = (array) $result ['result'];
                    $modules = (array) $result ['result'] ['modules'];
                    $version = $this->config->item('product_version'); // $request['result']['version'];
                    if (is_array($modules) && count($modules) > 0) {
                        foreach ($modules as $module) {
                            $module = (array) $module;
                            if (!$module_name || $module_name == $module ['keyword']) {
                                $module = $module ['keyword'];
                                $this->load->helper('Modules');
                                if (function_exists('get_module_by_keyword')) {
                                    $module_data = get_module_by_keyword($module);
                                } else {
                                    $module_data = false;
                                }
                                if ($module_data) {
                                    $result = $this->_download_module($product_key, $module, true, $module_data->module_version . '/' . $module_data->sub_version . '/' . $module_data->patch_version);
                                } else {
                                    $result = $this->_download_module($product_key, $module, true);
                                }
                                if ($result) {
                                    $file_content = $result;
                                    @unlink(TEMPPATH . 'downloads/' . $module . '.zip');
                                    $file_handle = @fopen(TEMPPATH . 'downloads/' . $module . '.zip', 'w');
                                    @fwrite($file_handle, $file_content);
                                    @fclose($file_handle);
                                    $zip_lib = new Pclzip(TEMPPATH . 'downloads/' . $module . '.zip');
                                    $result = $zip_lib->extract('./');
                                    @unlink(TEMPPATH . 'downloads/' . $module . '.zip');
                                }
                            }
                        }
                    }
                } else {
                    print_r($errors);
                }
            }
        }
        exit();
    }

}
