<?php

class Install_install_model extends N_Model {

    private $CI;
    private $module_version = 3;
    private $sub_version = 2;
    private $patch_version = 2;
    private $name = 'Installer';
    private $module_type = 'mandatory_product';
    private $keyword = 'install';

    public function __construct() {
        parent::__construct();
        $this->CI = get_instance();
    }

    public function install() {
        $this->CI->load->helper('Modules');
        if (function_exists('get_module_by_keyword')) {
            $module = get_module_by_keyword($this->keyword);
            if ($module) {
                $module->module_version = $this->module_version;
                $module->sub_version = $this->sub_version;
                $module->patch_version = $this->patch_version;
                
            } else {
                $module = array(
                    'keyword' => $this->keyword,
                    'name' => $this->name,
                    'module_type' => $this->module_type,
                    'module_version' => $this->module_version,
                    'sub_version' => $this->sub_version,
                    'patch_version' => $this->patch_version,
                );
            }
            if (function_exists('save_module')) {
                save_module($module);
            }
        }
    }

    public function update($module_version = 0, $sub_version = 0, $patch_version) {
        $this->CI->load->helper('Modules');
        if (function_exists('get_module_by_keyword')) {
            $module = get_module_by_keyword($this->keyword);
            if ($module) {
                $module->module_version = $this->module_version;
                $module->sub_version = $this->sub_version;
                $module->patch_version = $this->patch_version;
                
            } else {
                $module = array(
                    'keyword' => $this->keyword,
                    'name' => $this->name,
                    'module_type' => $this->module_type,
                    'module_version' => $this->module_version,
                    'sub_version' => $this->sub_version,
                    'patch_version' => $this->patch_version,
                );
            }
            if (function_exists('save_module')) {
                save_module($module);
            }
        }
    }

    public function install_languages() {
        $languages = array();
        if (file_exists(MODULESPATH . 'install/install/languages.php'))
            @include_once(MODULESPATH . 'install/install/languages.php');
        foreach ($languages as $language) {
            $this->db->delete('languages', array('key' => $language['key'], 'module' => $language['module']));
            $language['default'] = 1;
            $this->db->insert('languages', $language);
        }
        $this->db->cache_delete_prefix('languages');
    }

}