<?php

if (!function_exists('create_modules_table')) {

    function create_modules_table() {
        $CI = & get_instance();
        $CI->load->model('Modules_install_model');
        $CI->Modules_install_model->install();
    }

}

if (!function_exists('delete_module_by_keyword')) {

    function delete_module_by_keyword($keyword = '') {
        $CI = & get_instance();
        $CI->load->model('Modules_model');
        $CI->Modules_model->delete_module_by_keyword($keyword);
    }

}

if (!function_exists('save_module')) {

    function save_module($data = array()) {
        $CI = & get_instance();
        $CI->load->model('Modules_model');
        $id = $CI->Modules_model->save_module($data);
        return $id;
    }

}

if (!function_exists('get_modules_list')) {

    function get_modules_list($page = null, $items_on_page = null, $order_by = null, $params = array()) {
        $CI = & get_instance();
        $CI->load->model('Modules_model');
        if (isset($CI->db) && $CI->db) {
            $list = $CI->Modules_model->get_modules_list($page, $items_on_page, $order_by, $params);
            return $list;
        } else {
            return array();
        }
    }

}

if (!function_exists('get_module_by_keyword')) {

    function get_module_by_keyword($keyword = '') {
        $CI = & get_instance();
        $CI->load->model('Modules_model');
        if (isset($CI->db) && $CI->db) {
            $data = $CI->Modules_model->get_module_by_keyword($keyword);
            return $data;
        } else {
            return false;
        }
    }

}

if (!function_exists('get_module_by_id')) {

    function get_module_by_id($id = 0) {
        $CI = & get_instance();
        $CI->load->model('Modules_model');
        if (isset($CI->db) && $CI->db) {
            $data = $CI->Modules_model->get_module_by_id($id);
            return $data;
        } else {
            return false;
        }
    }

}

if (!function_exists('show_admin_left_menu_modules')) {

    function show_admin_left_menu_modules() {
        $CI = & get_instance();
        $hide_license_info = defined('HIDE_LICENSE_INFORMATION') && HIDE_LICENSE_INFORMATION ? true : false;
        $updates = get_updates();
        $data = array(
            'updates_count' => is_array($updates) ? count($updates) : 0,
            'hide_license_info' => $hide_license_info
        );
        $CI->load->helper('Options');
        $theme = 'admin';
        if (function_exists('load_options')) {
            $theme = load_options('theme_admin');
        }
        $theme = $theme ? $theme : 'admin';
        echo $CI->parser->parse(APPPATH . 'modules/modules/views/' . $theme . '/left_menu_modules.php', $data, TRUE);
    }

}

if (!function_exists('show_admin_modules_tab')) {

    function show_admin_modules_tab($filter = 'modules') {
        $CI = & get_instance();
        $hide_license_info = defined('HIDE_LICENSE_INFORMATION') && HIDE_LICENSE_INFORMATION ? true : false;
        $main_data = array(
            'filter' => $filter,
            'hide_license_info' => $hide_license_info
        );
        $CI->load->helper('Options');
        $theme = 'admin';
        if (function_exists('load_options')) {
            $theme = load_options('theme_admin');
        }
        $theme = $theme ? $theme : 'admin';
        return $CI->parser->parse(APPPATH . 'modules/modules/views/' . $theme . '/modules_tab2.php', $main_data, true);
    }

}

if (!function_exists('get_updates')) {

    function get_updates() {
        $CI = & get_instance();
        $CI->load->model('Modules_model');
        if (!isset($_SESSION))
            session_start();
        $updates = array();
        $modules = $CI->Modules_model->get_modules_list(null, null, array(
            'id' => 'asc'
                ));
        $product_key = $CI->config->item('product_key');
        if (!isset($_SESSION [$product_key . '_updates']) || !isset($_SESSION [$product_key . '_updates_time']) || $_SESSION [$product_key . '_updates_time'] < (time() - 3600)) {
            if (is_array($modules) && count($modules) > 0) {
                $errors = array();
                $license_key = $CI->config->item('product_key');
                $post_data = array();
                foreach ($modules as $module) {
                    $post_data [$module ['keyword']] = $module ['module_version'] . '.' . $module ['sub_version'] . '.' . $module ['patch_version'];
                }
                $url = $CI->config->item('license_api_url');
                $CI->load->library('Snoopy');
                $res = $CI->snoopy->submit($url . 'get_updates_info/' . $license_key . '/UNKNOWN', $post_data);
                $request = array();
                if ($res && isset($CI->snoopy->headers) && preg_match('/200 OK/', trim($CI->snoopy->headers [0]))) {
                    $request = json_decode($CI->snoopy->results);
                    $request = (array) $request;
                    if (isset($request ['errors']) && is_array($request ['errors']) && count($request) > 0) {
                        foreach ($request ['errors'] as $error) {
                            $errors [] = $error;
                        }
                    }
                } else {
                    $errors [] = $CI->lang->line('server_error');
                }
                if (count($errors) == 0) {
                    $request ['result'] = $request ['result'] ? (array) $request ['result'] : false;
                    if (is_array($request ['result']) && count($request ['result']) > 0) {
                        foreach ($request ['result'] as $module_keyword => $module_data) {
                            if ($module_data && $module_keyword) {
                                $updates [$module_keyword] = (array) $module_data;
                            }
                        }
                    }
                }
            }
            $_SESSION [$product_key . '_updates'] = $updates;
            $_SESSION [$product_key . '_updates_time'] = time();
        } else {
            $updates = $_SESSION [$product_key . '_updates'];
        }
        foreach ($modules as $id => $value) {
            if (isset($updates [$value ['keyword']])) {
                $updates [$value ['keyword']] ['current_version'] = $value ['module_version'] . '.' . $value ['sub_version'] . '.' . $value ['patch_version'];
                $updates [$value ['keyword']] ['module_version_id'] = $value ['module_version'];
            }
        }
        return $updates;
    }

}

if (!function_exists('get_paid_modules')) {

    function get_paid_modules() {
        $CI = & get_instance();
        if (!isset($_SESSION))
            session_start();
        $license_key = $CI->config->item('product_key');
        $post_data = array(
            'SERVER_NAME' => isset($_SERVER ['SERVER_NAME']) ? $_SERVER ['SERVER_NAME'] : '',
            'DOCUMENT_ROOT' => isset($_SERVER ['DOCUMENT_ROOT']) ? $_SERVER ['DOCUMENT_ROOT'] : '',
            'PHP_SELF' => isset($_SERVER ['PHP_SELF']) ? $_SERVER ['PHP_SELF'] : '',
            'HTTP_HOST' => isset($_SERVER ['HTTP_HOST']) ? $_SERVER ['HTTP_HOST'] : '',
            'SITE_URL' => site_url()
        );
        $url = $CI->config->item('license_api_url');
        $CI->load->library('Snoopy');
        $res = $CI->snoopy->submit($url . 'get_paid_modules/' . $license_key . '/UNKNOWN', $post_data);
        $request = array();
        $errors = array();
        if ($res && isset($CI->snoopy->headers) && preg_match('/200 OK/', trim($CI->snoopy->headers [0]))) {
            $request = json_decode($CI->snoopy->results);
            $request = (array) $request;
            if (isset($request ['errors']) && is_array($request ['errors']) && count($request) > 0) {
                foreach ($request ['errors'] as $error) {
                    $errors [] = $error;
                }
            }
        } else {
            $errors [] = $CI->lang->line('server_error');
        }
        if (count($errors) == 0) {
            $request ['result'] = $request ['result'] ? (array) $request ['result'] : false;
        }
        if (isset($request ['activation_key'])) {
            $_SESSION [$license_key . '_activation_key'] = $request ['activation_key'];
        }
        return $request;
    }

}

if (!function_exists('show_admin_paid_module_action')) {

    function show_admin_paid_module_action($module = array()) {
        $module = $module ? (array) $module : false;
        $CI = & get_instance();
        $real_module = get_module_by_keyword($module ['keyword']);
        $data = array(
            'real_module' => $real_module,
            'module' => $module
        );
        $CI->load->helper('Options');
        $theme = 'admin';
        if (function_exists('load_options')) {
            $theme = load_options('theme_admin');
        }
        $theme = $theme ? $theme : 'admin';
        echo $CI->parser->parse(APPPATH . 'modules/modules/views/' . $theme . '/paid_module_action.php', $data, TRUE);
    }

}

if (!function_exists('admin_main_quick_links_modules')) {

    function admin_main_quick_links_modules() {
        $CI = get_instance();
        $data = array();
        $CI->load->helper('Options');
        $theme = 'admin';
        if (function_exists('load_options')) {
            $theme = load_options('theme_admin');
        }
        $theme = $theme ? $theme : 'admin';
        return $CI->parser->parse(APPPATH . 'modules/modules/views/' . $theme . '/main_quick_links_block.php', $data, true);
    }

}

if (!function_exists('show_home_license_info')) {

    function show_home_license_info() {
        $CI = get_instance();
        $hide_license_info = defined('HIDE_LICENSE_INFORMATION') && HIDE_LICENSE_INFORMATION ? true : false;
        if (!$hide_license_info) {
            $product_key = $CI->config->item('product_key');
            $license_info = array();
            if ($product_key) {
                $post_data = array(
                    'SERVER_NAME' => isset($_SERVER ['SERVER_NAME']) ? $_SERVER ['SERVER_NAME'] : '',
                    'DOCUMENT_ROOT' => isset($_SERVER ['DOCUMENT_ROOT']) ? $_SERVER ['DOCUMENT_ROOT'] : '',
                    'PHP_SELF' => isset($_SERVER ['PHP_SELF']) ? $_SERVER ['PHP_SELF'] : '',
                    'HTTP_HOST' => isset($_SERVER ['HTTP_HOST']) ? $_SERVER ['HTTP_HOST'] : '',
                    'SITE_URL' => site_url()
                );
                $url = $CI->config->item('license_api_url');
                $CI->load->library('Snoopy');
                $res = $CI->snoopy->submit($url . 'check_license/' . $product_key, $post_data);
                if ($res && isset($CI->snoopy->headers) && preg_match('/200 OK/', trim($CI->snoopy->headers [0]))) {
                    $license_info = json_decode($CI->snoopy->results);
                    if ($license_info) {
                        $license_info = (array) $license_info;
                    }
                }
            }
            if (!is_array($license_info)) {
                $license_info = array();
            }
            if (isset($license_info ['errors']) && is_array($license_info ['errors']) && count($license_info ['errors']) > 0) {
                if (!isset($_SESSION)) {
                    @session_start();
                }
                $_SESSION ['license_errors'] = $license_info ['errors'];
            }
            if (isset($license_info ['license_type'])) {
                $data = array(
                    'license_info' => $license_info
                );
                $CI->load->helper('Options');
                $theme = 'admin';
                if (function_exists('load_options')) {
                    $theme = load_options('theme_admin');
                }
                $theme = $theme ? $theme : 'admin';
                return $CI->parser->parse(APPPATH . 'modules/modules/views/' . $theme . '/home_license_info.php', $data, true);
            }
        }
    }

}
