<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Modules_model extends CI_Model {

    public $CI;
    public $temp_db_modules = array();
    public $temp_db_modules_by_id = array();
    private $connection_id;

    public function __construct() {
        parent::__construct();
        $this->CI = get_instance();
    }

    function _process_active_records($page = null, $items_on_page = null, $order_by = null, $attrs = array()) {
        if (isset($attrs ["where_sql"]) && is_array($attrs ["where_sql"]) && count($attrs ["where_sql"]) > 0) {
            foreach ($attrs ["where_sql"] as $value) {
                $this->db->where($value, null, false);
            }
        }
        if (isset($attrs ["where"]) && is_array($attrs ["where"]) && count($attrs ["where"]) > 0) {
            foreach ($attrs ["where"] as $key => $value) {
                $this->db->where($key, $value);
            }
        }
        if (isset($attrs ["or_where"]) && is_array($attrs ["or_where"]) && count($attrs ["or_where"]) > 0) {
            foreach ($attrs ["or_where"] as $key => $value) {
                $this->db->or_where($key, $value);
            }
        }
        if (isset($attrs ["where_not_in"]) && is_array($attrs ["where_not_in"]) && count($attrs ["where_not_in"]) > 0) {
            foreach ($attrs ["where_not_in"] as $key => $value) {
                $this->db->where_not_in($key, $value);
            }
        }
        if (isset($attrs ["or_where_not_in"]) && is_array($attrs ["or_where_not_in"]) && count($attrs ["or_where_not_in"]) > 0) {
            foreach ($attrs ["or_where_not_in"] as $key => $value) {
                $this->db->or_where_not_in($key, $value);
            }
        }
        if (isset($attrs ["like"]) && is_array($attrs ["like"]) && count($attrs ["like"]) > 0) {
            foreach ($attrs ["like"] as $key => $value) {
                $this->db->like($key, $value);
            }
        }
        if (isset($attrs ["or_like"]) && is_array($attrs ["or_like"]) && count($attrs ["or_like"]) > 0) {
            foreach ($attrs ["or_like"] as $key => $value) {
                $this->db->or_like($key, $value);
            }
        }
        if (isset($attrs ["not_like"]) && is_array($attrs ["not_like"]) && count($attrs ["not_like"]) > 0) {
            foreach ($attrs ["not_like"] as $key => $value) {
                $this->db->not_like($key, $value);
            }
        }
        if (isset($attrs ["or_not_like"]) && is_array($attrs ["or_not_like"]) && count($attrs ["or_not_like"]) > 0) {
            foreach ($attrs ["or_not_like"] as $key => $value) {
                $this->db->or_not_like($key, $value);
            }
        }
        if (isset($attrs ["where_in"]) && is_array($attrs ["where_in"]) && count($attrs ["where_in"]) > 0) {
            foreach ($attrs ["where_in"] as $key => $value) {
                $this->db->where_in($key, $value);
            }
        }
        if (isset($attrs ["or_where_in"]) && is_array($attrs ["or_where_in"]) && count($attrs ["or_where_in"]) > 0) {
            foreach ($attrs ["or_where_in"] as $key => $value) {
                $this->db->or_where_in($key, $value);
            }
        }
        if (isset($attrs ["having"]) && is_array($attrs ["having"]) && count($attrs ["having"]) > 0) {
            foreach ($attrs ["having"] as $key => $value) {
                $this->db->having($key, $value);
            }
        }
        if (isset($attrs ["or_having"]) && is_array($attrs ["or_having"]) && count($attrs ["or_having"]) > 0) {
            foreach ($attrs ["or_having"] as $key => $value) {
                $this->db->or_having($key, $value);
            }
        }
        if (is_array($order_by) && count($order_by) > 0) {
            foreach ($order_by as $key => $value) {
                $this->db->order_by($key . " " . $value);
            }
        }
        if (!is_null($page)) {
            $page = $page ? floor($page) : 1;
            $this->db->limit($items_on_page, $items_on_page * ($page - 1));
        }
    }

    function get_module_by_keyword($keyword = '') {
        $keyword = format_keyword($keyword);
        if (!isset($this->temp_db_modules[$keyword])) {
            $query = $this->db->get_where('modules', array('keyword' => $keyword));
            if ($query->num_rows() > 0) {
                $data = $query->row();
                $this->temp_db_modules[$data->keyword] = $data;
                $this->temp_db_modules_by_id[$data->id] = $data;
                return $data;
            }
        } else {
            return $this->temp_db_modules[$keyword];
        }
    }

    function get_module_by_id($id = 0) {
        $id = floor($id);
        if (!isset($this->temp_db_modules_by_id[$id])) {
            $query = $this->db->get_where('modules', array('id' => $id));
            if ($query->num_rows() > 0) {
                $data = $query->row();
                $this->temp_db_modules[$data->keyword] = $data;
                $this->temp_db_modules_by_id[$data->id] = $data;
                return $data;
            }
        } else {
            return $this->temp_db_modules_by_id[$id];
        }
    }

    public function save_module($data = array()) {
        $data = (array) $data;
        $id = 0;
        if (isset($data['id'])) {
            $data['date_modified'] = time();
            $keyword = $data['keyword'];
            $this->db->where(array('keyword' => $keyword));
            $this->db->update('modules', $data);
        } else {
            $data['date_created'] = time();
            $this->db->insert('modules', $data);
            $id = $this->db->insert_id();
        }
        return;
    }

    function get_modules_list($page = null, $items_on_page = null, $order_by = null, $attrs = array()) {
        $this->db->from('modules');
        $this->_process_active_records($page, $items_on_page, $order_by, $attrs);
        $query = $this->db->get();
        $results = $query->result_array();
        if (is_array($results) && count($results) > 0) {
            return $results;
        }
    }

    function get_modules_count($attrs = array()) {
        $this->db->from('modules');
        $this->_process_active_records(null, null, null, $attrs);
        return $this->db->count_all_results();
    }

    function delete_module_by_keyword($keyword = '') {
        $this->db->where('keyword', strip_tags($keyword));
        $this->db->delete('modules');
    }

    function is_file_writable($file = '', $mode = 0777) {
        @chmod($file, $mode);
        clearstatcache();
        if (!is_writable($file)) {
            if (!$this->connection_id) {
                $this->CI->config->load('ftp', true);
                $ftp_settings = $this->CI->config->item('ftp');
                $ftp_host = '';
                $ftp_user = '';
                $ftp_pass = '';
                if (isset($ftp_settings['hostname'])) {
                    $ftp_host = $ftp_settings['hostname'];
                }
                if (isset($ftp_settings['username'])) {
                    $ftp_user = $ftp_settings['username'];
                }
                if (isset($ftp_settings['password'])) {
                    $ftp_pass = $ftp_settings['password'];
                }
                if ($ftp_host && $ftp_user && $ftp_pass) {
                    $this->connection_id = @ftp_connect($ftp_host);
                    $login_result = false;
                    if ($this->connection_id) {
                        @ftp_login($this->connection_id, $ftp_user, $ftp_pass);
                    }
                }
            }
            @ftp_chmod($this->connection_id, $mode, $file);
        }
        @ftp_close($this->connection_id);
        return is_writable($file);
    }

}
